# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.CivicInfo.V2.Model.StreetSegment do
  @moduledoc """


  ## Attributes

  *   `voterGeographicDivisionOcdIds` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `stateSenateDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `startHouseNumber` (*type:* `String.t`, *default:* `nil`) - 
  *   `catalistUniquePrecinctCode` (*type:* `String.t`, *default:* `nil`) - 
  *   `endHouseNumber` (*type:* `String.t`, *default:* `nil`) - 
  *   `townshipDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `mailOnly` (*type:* `boolean()`, *default:* `nil`) - 
  *   `judicialDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `zip` (*type:* `String.t`, *default:* `nil`) - 
  *   `schoolDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `administrationRegionIds` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `provenances` (*type:* `list(GoogleApi.CivicInfo.V2.Model.Provenance.t)`, *default:* `nil`) - 
  *   `wardDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `cityCouncilDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `beforeGeocodeId` (*type:* `String.t`, *default:* `nil`) - 
  *   `city` (*type:* `String.t`, *default:* `nil`) - 
  *   `wildcard` (*type:* `boolean()`, *default:* `nil`) - 
  *   `earlyVoteSiteByIds` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `precinctOcdId` (*type:* `String.t`, *default:* `nil`) - 
  *   `targetsmartUniquePrecinctCode` (*type:* `String.t`, *default:* `nil`) - 
  *   `countyFips` (*type:* `String.t`, *default:* `nil`) - 
  *   `state` (*type:* `String.t`, *default:* `nil`) - 
  *   `originalId` (*type:* `String.t`, *default:* `nil`) - 
  *   `datasetId` (*type:* `String.t`, *default:* `nil`) - 
  *   `oddOrEvens` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `countyCouncilDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `pollinglocationByIds` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `surrogateId` (*type:* `String.t`, *default:* `nil`) - 
  *   `subAdministrativeAreaName` (*type:* `String.t`, *default:* `nil`) - 
  *   `streetName` (*type:* `String.t`, *default:* `nil`) - 
  *   `id` (*type:* `String.t`, *default:* `nil`) - 
  *   `municipalDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `startLngE7` (*type:* `integer()`, *default:* `nil`) - 
  *   `geocodedPoint` (*type:* `GoogleApi.CivicInfo.V2.Model.PointProto.t`, *default:* `nil`) - 
  *   `contestIds` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `published` (*type:* `boolean()`, *default:* `nil`) - 
  *   `startLatE7` (*type:* `integer()`, *default:* `nil`) - 
  *   `vanPrecinctCode` (*type:* `String.t`, *default:* `nil`) - 
  *   `geographicDivisionOcdIds` (*type:* `list(String.t)`, *default:* `nil`) - 
  *   `precinctName` (*type:* `String.t`, *default:* `nil`) - 
  *   `stateHouseDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `congressionalDistrict` (*type:* `String.t`, *default:* `nil`) - 
  *   `unitNumber` (*type:* `String.t`, *default:* `nil`) - 
  *   `unitType` (*type:* `String.t`, *default:* `nil`) - 
  *   `ncoaAddress` (*type:* `String.t`, *default:* `nil`) - 
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :voterGeographicDivisionOcdIds => list(String.t()),
          :stateSenateDistrict => String.t(),
          :startHouseNumber => String.t(),
          :catalistUniquePrecinctCode => String.t(),
          :endHouseNumber => String.t(),
          :townshipDistrict => String.t(),
          :mailOnly => boolean(),
          :judicialDistrict => String.t(),
          :zip => String.t(),
          :schoolDistrict => String.t(),
          :administrationRegionIds => list(String.t()),
          :provenances => list(GoogleApi.CivicInfo.V2.Model.Provenance.t()),
          :wardDistrict => String.t(),
          :cityCouncilDistrict => String.t(),
          :beforeGeocodeId => String.t(),
          :city => String.t(),
          :wildcard => boolean(),
          :earlyVoteSiteByIds => list(String.t()),
          :precinctOcdId => String.t(),
          :targetsmartUniquePrecinctCode => String.t(),
          :countyFips => String.t(),
          :state => String.t(),
          :originalId => String.t(),
          :datasetId => String.t(),
          :oddOrEvens => list(String.t()),
          :countyCouncilDistrict => String.t(),
          :pollinglocationByIds => list(String.t()),
          :surrogateId => String.t(),
          :subAdministrativeAreaName => String.t(),
          :streetName => String.t(),
          :id => String.t(),
          :municipalDistrict => String.t(),
          :startLngE7 => integer(),
          :geocodedPoint => GoogleApi.CivicInfo.V2.Model.PointProto.t(),
          :contestIds => list(String.t()),
          :published => boolean(),
          :startLatE7 => integer(),
          :vanPrecinctCode => String.t(),
          :geographicDivisionOcdIds => list(String.t()),
          :precinctName => String.t(),
          :stateHouseDistrict => String.t(),
          :congressionalDistrict => String.t(),
          :unitNumber => String.t(),
          :unitType => String.t(),
          :ncoaAddress => String.t()
        }

  field(:voterGeographicDivisionOcdIds, type: :list)
  field(:stateSenateDistrict)
  field(:startHouseNumber)
  field(:catalistUniquePrecinctCode)
  field(:endHouseNumber)
  field(:townshipDistrict)
  field(:mailOnly)
  field(:judicialDistrict)
  field(:zip)
  field(:schoolDistrict)
  field(:administrationRegionIds, type: :list)
  field(:provenances, as: GoogleApi.CivicInfo.V2.Model.Provenance, type: :list)
  field(:wardDistrict)
  field(:cityCouncilDistrict)
  field(:beforeGeocodeId)
  field(:city)
  field(:wildcard)
  field(:earlyVoteSiteByIds, type: :list)
  field(:precinctOcdId)
  field(:targetsmartUniquePrecinctCode)
  field(:countyFips)
  field(:state)
  field(:originalId)
  field(:datasetId)
  field(:oddOrEvens, type: :list)
  field(:countyCouncilDistrict)
  field(:pollinglocationByIds, type: :list)
  field(:surrogateId)
  field(:subAdministrativeAreaName)
  field(:streetName)
  field(:id)
  field(:municipalDistrict)
  field(:startLngE7)
  field(:geocodedPoint, as: GoogleApi.CivicInfo.V2.Model.PointProto)
  field(:contestIds, type: :list)
  field(:published)
  field(:startLatE7)
  field(:vanPrecinctCode)
  field(:geographicDivisionOcdIds, type: :list)
  field(:precinctName)
  field(:stateHouseDistrict)
  field(:congressionalDistrict)
  field(:unitNumber)
  field(:unitType)
  field(:ncoaAddress)
end

defimpl Poison.Decoder, for: GoogleApi.CivicInfo.V2.Model.StreetSegment do
  def decode(value, options) do
    GoogleApi.CivicInfo.V2.Model.StreetSegment.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.CivicInfo.V2.Model.StreetSegment do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
